using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using PhoenixDLL.Class.Managers;
using Utils.DataBase;
using PhoenixDLL.Class;
using Utils.Logs;

namespace PhoenixMoney.GUI
{
    /// <summary>
    /// Debt manager
    /// </summary>
    public partial class fr_DebtManager : Form
    {
        #region Variables
        /// <summary>
        /// Information about patient
        /// </summary>
        private PatientManager vPatientManager;
        #endregion

        #region Constructor
        /// <summary>
        /// Constructor
        /// </summary>
        public fr_DebtManager() { InitializeComponent(); }
        #endregion

        #region Events
        /// <summary>
        /// Ok pressed => pay the debt
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Click_OK(object sender, EventArgs e)
        {
            if ((int)nud_Debt.Value - vPatientManager.Debt == 0)
            {
                try
                {
                    vPatientManager.SubDebt((int)vPatientManager.Debt);
                    vPatientManager.Update();
                    OleDbSql sm = new OleDbSql(Options.Instance.Path);
                    sm.SqlQuery = "UPDATE RendezVous SET a_paye = TRUE AND Debut >= Date() AND"
                        + " id_patient = " + this.vPatientManager.IDPatient
                        + " AND came_to_rdv = TRUE;";
                }
                catch (ArgumentException)
                {
                    MessageBox.Show("Le patient ne peut pas payer une somme d'argent suprieure  sa dette!",
                        "Remarque", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                catch (Exception ex)
                {
                    Log.Instance.Write(ex, this, LogType.Error);
                    MessageBox.Show("La mise  jour de la dette n'a pas t excute!",
                        "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }
            }
            else
            {
                try
                {
                    vPatientManager.SubDebt((int)nud_Debt.Value);
                    vPatientManager.Update();
                }
                catch (ArgumentException)
                {
                    MessageBox.Show("Le patient ne peut pas payer une somme d'argent suprieure  sa dette!",
                        "Remarque", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                catch (Exception ex)
                {
                    Log.Instance.Write(ex, this, LogType.Error);
                    MessageBox.Show("La mise  jour de la dette n'a pas t excute!",
                        "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                }

            }
            base.DialogResult = DialogResult.OK;
            this.Close();
        }
        /// <summary>
        /// Frame is loading
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Event_FrameLoad(object sender, EventArgs e)
        {
            try
            {
                lbl_Debt.Text = "Dette ( " + vPatientManager.Debt + ")";
                lbl_Nom.Text = vPatientManager.Surname + " " + vPatientManager.FamillyName.ToUpper();                
                nud_Debt.Minimum = 0;
            }
            catch (Exception ex)
            {
                MessageBox.Show("Une erreur est survenue lors du chargement de la fentre!",
                    "Erreur", MessageBoxButtons.OK, MessageBoxIcon.Error);
                Log.Instance.Write(ex, this, LogType.Error);
            }
        }
        #endregion

        #region Properties
        /// <summary>
        /// Gets or sets the PatientManager to manage de debt
        /// </summary>
        public PatientManager PatientManager
        {
            get { return vPatientManager; }
            set { vPatientManager = value; }
        }
        #endregion
    }
}