using System;
using System.Collections.Generic;
using System.Text;

namespace Utils.Logs.Exceptions
{
    /// <summary>
    /// Exception thrown when an error occures in the logs
    /// </summary>
   public class LogException : Exception
    {
        /// <summary>
        /// Constructor
        /// </summary>
        public LogException() : base("An error occured in the logs") { }
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="_Message">Error message</param>
        public LogException(string _Message) : base(_Message) { }
    }
    /// <summary>
    /// Thrown when the string to parse is not a log entry
    /// </summary>
    public class BadLogParseException : Exception
    {
        /// <summary>
        /// Constructor
        /// </summary>
        public BadLogParseException() : base("Impossible to parse the string") { }
        /// <summary>
        /// Constructor
        /// </summary>
        /// <param name="_Message">Explanation of the parse error</param>
        public BadLogParseException(string _Message) :base("Impossible to parse the string (" + _Message +")")
        { }
    }    
}
