using System;
using System.Collections.Generic;
using System.Text;

namespace Utils.Misc
{
    /// <summary>
    /// Class wich gives the path of the running application
    /// </summary>
    public static class ApplicationPath
    {
        #region Properties
        /// <summary>
        /// Gives the command line of this running application
        /// </summary>
        public static string CommandLine { get { return Environment.CommandLine; } }

        /// <summary>
        /// Gives the execution path of this running application but DOES NOT finish with a "\"
        /// </summary>
        public static string CommandPath
        {
            get
            {
                string[] args = Environment.GetCommandLineArgs();
                string Path = args[0];

                return GetDirectoryFrom(Path);
                //int index = Path.LastIndexOf("\\");
                //if (index > 0)
                //    Path = Path.Remove(index);
                //Path = Path.Trim('\"');
                //return Path;
            }
        }
        #endregion

        #region Methods
        /// <summary>
        /// Return the path without the executable name
        /// </summary>
        /// <param name="_Path">The full path with the executable name</param>
        /// <returns>The path without the executable name</returns>
        public static string GetDirectoryFrom(string _Path)
        {
            int index = _Path.LastIndexOf("\\");
            if (index > 0)
                _Path = _Path.Remove(index);
            return _Path.Trim('\"');
        }
        #endregion
    }
}
